Rewrite of ensure-dirs in python
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Use bash in order to be able to use pipefail
13 SHELL=/bin/bash
14
15 ACLOCAL_AMFLAGS = -I autotools
16 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
17 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
18 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
19 CHECK_MAN = $(top_srcdir)/autotools/check-man
20 CHECK_VERSION = $(top_srcdir)/autotools/check-version
21 CHECK_NEWS = $(top_srcdir)/autotools/check-news
22 DOCPP = $(top_srcdir)/autotools/docpp
23 REPLACE_VARS_SED = autotools/replace_vars.sed
24
25 # Note: these are automake-specific variables, and must be named after
26 # the directory + 'dir' suffix
27 clientdir = $(pkgpythondir)/client
28 hypervisordir = $(pkgpythondir)/hypervisor
29 httpdir = $(pkgpythondir)/http
30 masterddir = $(pkgpythondir)/masterd
31 confddir = $(pkgpythondir)/confd
32 rapidir = $(pkgpythondir)/rapi
33 serverdir = $(pkgpythondir)/server
34 watcherdir = $(pkgpythondir)/watcher
35 impexpddir = $(pkgpythondir)/impexpd
36 utilsdir = $(pkgpythondir)/utils
37 toolsdir = $(pkglibdir)/tools
38 iallocatorsdir = $(pkglibdir)/iallocators
39 pytoolsdir = $(pkgpythondir)/tools
40 docdir = $(datadir)/doc/$(PACKAGE)
41
42 # Delete output file if an error occurred while building it
43 .DELETE_ON_ERROR:
44
45 HTOOLS_DIRS = \
46         htools \
47         htools/Ganeti \
48         htools/Ganeti/HTools
49
50 DIRS = \
51         autotools \
52         daemons \
53         devel \
54         doc \
55         doc/examples \
56         doc/examples/hooks \
57         doc/examples/gnt-debug \
58         $(HTOOLS_DIRS) \
59         lib \
60         lib/client \
61         lib/build \
62         lib/confd \
63         lib/http \
64         lib/hypervisor \
65         lib/impexpd \
66         lib/masterd \
67         lib/rapi \
68         lib/server \
69         lib/tools \
70         lib/utils \
71         lib/watcher \
72         man \
73         qa \
74         test \
75         test/data \
76         tools
77
78 BUILDTIME_DIR_AUTOCREATE = \
79         scripts \
80         $(APIDOC_DIR) \
81         $(APIDOC_PY_DIR) \
82         $(APIDOC_HS_DIR) \
83         $(APIDOC_HS_DIR)/Ganeti $(APIDOC_HS_DIR)/Ganeti/HTools \
84         $(COVERAGE_DIR) \
85         $(COVERAGE_PY_DIR) \
86         $(COVERAGE_HS_DIR) \
87         .hpc
88
89 BUILDTIME_DIRS = \
90         $(BUILDTIME_DIR_AUTOCREATE) \
91         doc/html
92
93 DIRCHECK_EXCLUDE = \
94         $(BUILDTIME_DIRS) \
95         ganeti-[0-9]*.[0-9]*.[0-9]* \
96         doc/html/_*
97
98 all_dirfiles = $(addsuffix /.dir,$(DIRS) $(BUILDTIME_DIR_AUTOCREATE))
99
100 # some helper vars
101 COVERAGE_DIR = doc/coverage
102 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
103 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
104 APIDOC_DIR = doc/api
105 APIDOC_PY_DIR = $(APIDOC_DIR)/py
106 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
107
108 MAINTAINERCLEANFILES = \
109         $(docpng) \
110         $(maninput) \
111         doc/install-quick.rst \
112         doc/news.rst \
113         doc/upgrade.rst \
114         vcs-version
115
116 maintainer-clean-local:
117         rm -rf $(BUILDTIME_DIRS)
118
119 CLEANFILES = \
120         $(addsuffix /*.py[co],$(DIRS)) \
121         $(addsuffix /*.hi,$(HTOOLS_DIRS)) \
122         $(addsuffix /*.o,$(HTOOLS_DIRS)) \
123         $(all_dirfiles) \
124         $(PYTHON_BOOTSTRAP) \
125         epydoc.conf \
126         autotools/replace_vars.sed \
127         daemons/daemon-util \
128         daemons/ensure-dirs \
129         daemons/ganeti-cleaner \
130         devel/upload \
131         doc/examples/bash_completion \
132         doc/examples/ganeti.initd \
133         doc/examples/ganeti-kvm-poweroff.initd \
134         doc/examples/ganeti.cron \
135         doc/examples/gnt-config-backup \
136         doc/examples/hooks/ipsec \
137         $(man_MANS) \
138         $(manhtml) \
139         tools/kvm-ifup \
140         stamp-srclinks \
141         $(nodist_pkgpython_PYTHON) \
142         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
143         .hpc/*.mix htools/*.tix \
144         doc/hs-lint.html
145
146 # BUILT_SOURCES should only be used as a dependency on phony targets. Otherwise
147 # it'll cause the target to rebuild every time.
148 BUILT_SOURCES = \
149         ganeti \
150         stamp-srclinks \
151         lib/_autoconf.py \
152         $(all_dirfiles) \
153         $(PYTHON_BOOTSTRAP)
154
155 nodist_pkgpython_PYTHON = \
156         lib/_autoconf.py
157
158 noinst_PYTHON = \
159         lib/build/__init__.py \
160         lib/build/sphinx_ext.py
161
162 pkgpython_PYTHON = \
163         lib/__init__.py \
164         lib/asyncnotifier.py \
165         lib/backend.py \
166         lib/bdev.py \
167         lib/bootstrap.py \
168         lib/cli.py \
169         lib/cmdlib.py \
170         lib/compat.py \
171         lib/config.py \
172         lib/constants.py \
173         lib/daemon.py \
174         lib/errors.py \
175         lib/ht.py \
176         lib/jqueue.py \
177         lib/jstore.py \
178         lib/locking.py \
179         lib/luxi.py \
180         lib/mcpu.py \
181         lib/netutils.py \
182         lib/objects.py \
183         lib/opcodes.py \
184         lib/qlang.py \
185         lib/query.py \
186         lib/rpc.py \
187         lib/runtime.py \
188         lib/serializer.py \
189         lib/ssconf.py \
190         lib/ssh.py \
191         lib/storage.py \
192         lib/uidpool.py \
193         lib/workerpool.py
194
195 client_PYTHON = \
196         lib/client/__init__.py \
197         lib/client/gnt_backup.py \
198         lib/client/gnt_cluster.py \
199         lib/client/gnt_debug.py \
200         lib/client/gnt_group.py \
201         lib/client/gnt_instance.py \
202         lib/client/gnt_job.py \
203         lib/client/gnt_node.py \
204         lib/client/gnt_os.py
205
206 hypervisor_PYTHON = \
207         lib/hypervisor/__init__.py \
208         lib/hypervisor/hv_base.py \
209         lib/hypervisor/hv_chroot.py \
210         lib/hypervisor/hv_fake.py \
211         lib/hypervisor/hv_kvm.py \
212         lib/hypervisor/hv_lxc.py \
213         lib/hypervisor/hv_xen.py
214
215 rapi_PYTHON = \
216         lib/rapi/__init__.py \
217         lib/rapi/baserlib.py \
218         lib/rapi/client.py \
219         lib/rapi/client_utils.py \
220         lib/rapi/connector.py \
221         lib/rapi/rlib2.py
222
223 http_PYTHON = \
224         lib/http/__init__.py \
225         lib/http/auth.py \
226         lib/http/client.py \
227         lib/http/server.py
228
229 confd_PYTHON = \
230         lib/confd/__init__.py \
231         lib/confd/client.py \
232         lib/confd/querylib.py \
233         lib/confd/server.py
234
235 masterd_PYTHON = \
236         lib/masterd/__init__.py \
237         lib/masterd/instance.py
238
239 impexpd_PYTHON = \
240         lib/impexpd/__init__.py
241
242 watcher_PYTHON = \
243         lib/watcher/__init__.py
244
245 server_PYTHON = \
246         lib/server/__init__.py \
247         lib/server/confd.py \
248         lib/server/masterd.py \
249         lib/server/noded.py \
250         lib/server/rapi.py
251
252 pytools_PYTHON = \
253         lib/tools/__init__.py \
254         lib/tools/ensure_dirs.py
255
256 utils_PYTHON = \
257         lib/utils/__init__.py \
258         lib/utils/algo.py \
259         lib/utils/filelock.py \
260         lib/utils/hash.py \
261         lib/utils/io.py \
262         lib/utils/log.py \
263         lib/utils/mlock.py \
264         lib/utils/nodesetup.py \
265         lib/utils/process.py \
266         lib/utils/retry.py \
267         lib/utils/text.py \
268         lib/utils/wrapper.py \
269         lib/utils/x509.py
270
271 docrst = \
272         doc/admin.rst \
273         doc/design-2.0.rst \
274         doc/design-2.1.rst \
275         doc/design-2.2.rst \
276         doc/design-2.3.rst \
277         doc/design-htools-2.3.rst \
278         doc/design-2.4.rst \
279         doc/design-draft.rst \
280         doc/design-oob.rst \
281         doc/design-query2.rst \
282         doc/design-x509-ca.rst \
283         doc/design-http-server.rst \
284         doc/design-impexp2.rst \
285         doc/design-lu-generated-jobs.rst \
286         doc/cluster-merge.rst \
287         doc/design-shared-storage.rst \
288         doc/devnotes.rst \
289         doc/glossary.rst \
290         doc/hooks.rst \
291         doc/iallocator.rst \
292         doc/index.rst \
293         doc/install-quick.rst \
294         doc/install.rst \
295         doc/locking.rst \
296         doc/move-instance.rst \
297         doc/news.rst \
298         doc/rapi.rst \
299         doc/security.rst \
300         doc/upgrade.rst \
301         doc/walkthrough.rst
302
303 HS_PROGS = \
304         htools/hbal \
305         htools/hscan \
306         htools/hail \
307         htools/hspace
308
309 HS_ALL_PROGS = $(HS_PROGS) htools/test
310 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
311 # we don't add -Werror by default
312 HFLAGS = -O -Wall -fwarn-monomorphism-restriction -fwarn-tabs -ihtools
313 # extra flags that can be overriden on the command line
314 HEXTRA =
315 # exclude options for coverage reports
316 HPCEXCL = --exclude Main --exclude Ganeti.HTools.QC
317
318 HS_LIB_SRCS = \
319         htools/Ganeti/HTools/CLI.hs \
320         htools/Ganeti/HTools/Cluster.hs \
321         htools/Ganeti/HTools/Container.hs \
322         htools/Ganeti/HTools/ExtLoader.hs \
323         htools/Ganeti/HTools/Group.hs \
324         htools/Ganeti/HTools/IAlloc.hs \
325         htools/Ganeti/HTools/Instance.hs \
326         htools/Ganeti/HTools/Loader.hs \
327         htools/Ganeti/HTools/Luxi.hs \
328         htools/Ganeti/HTools/Node.hs \
329         htools/Ganeti/HTools/PeerMap.hs \
330         htools/Ganeti/HTools/QC.hs \
331         htools/Ganeti/HTools/Rapi.hs \
332         htools/Ganeti/HTools/Simu.hs \
333         htools/Ganeti/HTools/Text.hs \
334         htools/Ganeti/HTools/Types.hs \
335         htools/Ganeti/HTools/Utils.hs \
336         htools/Ganeti/Jobs.hs \
337         htools/Ganeti/Luxi.hs \
338         htools/Ganeti/OpCodes.hs
339
340 HS_BUILT_SRCS = htools/Ganeti/HTools/Version.hs
341 HS_BUILT_SRCS_IN = $(patsubst %,%.in,$(HS_BUILT_SRCS))
342
343 $(RUN_IN_TEMPDIR): | $(all_dirfiles)
344
345 # Note: we use here an order-only prerequisite, as the contents of
346 # _autoconf.py are not actually influencing the html build output: it
347 # has to exist in order for the sphinx module to be loaded
348 # successfully, but we certainly don't want the docs to be rebuilt if
349 # it changes
350 doc/html/index.html: $(docrst) $(docpng) doc/conf.py configure.ac \
351         $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py lib/opcodes.py lib/ht.py \
352         | lib/_autoconf.py
353         @test -n "$(SPHINX)" || \
354             { echo 'sphinx-build' not found during configure; exit 1; }
355         @mkdir_p@ $(dir $@)
356         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(SPHINX) -q -W -b html \
357             -d . \
358             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
359             -D release="$(PACKAGE_VERSION)" \
360             $(abs_top_srcdir)/doc $(CURDIR)/doc/html
361         rm -f doc/html/.buildinfo doc/html/objects.inv
362         touch $@
363
364 doc/html: doc/html/index.html
365
366 doc/install-quick.rst: INSTALL
367 doc/news.rst: NEWS
368 doc/upgrade.rst: UPGRADE
369
370 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
371         set -e; \
372         { echo '.. This file is automatically updated at build time from $<.'; \
373           echo '.. Do not edit.'; \
374           echo; \
375           cat $<; \
376         } > $@
377
378 docdot = \
379         doc/arch-2.0.dot \
380         doc/design-2.1-lock-acquire.dot \
381         doc/design-2.1-lock-release.dot
382
383 docpng = $(patsubst %.dot,%.png,$(docdot))
384
385 # Things to build but not to install (add it to EXTRA_DIST if it should be
386 # distributed)
387 noinst_DATA = \
388         devel/upload \
389         doc/html \
390         doc/examples/bash_completion \
391         doc/examples/ganeti.cron \
392         doc/examples/ganeti.initd \
393         doc/examples/ganeti-kvm-poweroff.initd \
394         doc/examples/gnt-config-backup \
395         doc/examples/hooks/ipsec \
396         $(manhtml)
397
398 gnt_scripts = \
399         scripts/gnt-backup \
400         scripts/gnt-cluster \
401         scripts/gnt-debug \
402         scripts/gnt-group \
403         scripts/gnt-instance \
404         scripts/gnt-job \
405         scripts/gnt-node \
406         scripts/gnt-os
407
408 PYTHON_BOOTSTRAP_SBIN = \
409         daemons/ganeti-confd \
410         daemons/ganeti-masterd \
411         daemons/ganeti-noded \
412         daemons/ganeti-watcher \
413         daemons/ganeti-rapi \
414         scripts/gnt-backup \
415         scripts/gnt-cluster \
416         scripts/gnt-debug \
417         scripts/gnt-group \
418         scripts/gnt-instance \
419         scripts/gnt-job \
420         scripts/gnt-node \
421         scripts/gnt-os
422
423 PYTHON_BOOTSTRAP = \
424         $(PYTHON_BOOTSTRAP_SBIN) \
425         tools/ensure-dirs
426
427 qa_scripts = \
428         qa/ganeti-qa.py \
429         qa/qa_cluster.py \
430         qa/qa_config.py \
431         qa/qa_daemon.py \
432         qa/qa_env.py \
433         qa/qa_error.py \
434         qa/qa_instance.py \
435         qa/qa_node.py \
436         qa/qa_os.py \
437         qa/qa_rapi.py \
438         qa/qa_tags.py \
439         qa/qa_utils.py
440
441 bin_SCRIPTS =
442 iallocators_SCRIPTS =
443 if WANT_HTOOLS
444 bin_SCRIPTS += $(filter-out htools/hail,$(HS_PROGS))
445 iallocators_SCRIPTS += $(filter htools/hail,$(HS_PROGS))
446 endif
447
448 $(HS_ALL_PROGS): %: %.hs $(HS_LIB_SRCS) $(HS_BUILT_SRCS) Makefile
449         BINARY=$(@:htools/%=%); \
450         $(GHC) --make \
451           $(HFLAGS) $(HEXTRA) $(HTOOLS_NOCURL) \
452           -osuf $$BINARY.o -hisuf $$BINARY.hi \
453           $@
454
455 # for the htools/test binary, we need to enable profiling/coverage
456 htools/test: HEXTRA=-fhpc -Wwarn -fno-warn-missing-signatures \
457         -fno-warn-monomorphism-restriction -fno-warn-orphans \
458         -fno-warn-missing-methods -fno-warn-unused-imports
459
460 dist_sbin_SCRIPTS = \
461         tools/ganeti-listrunner
462
463 nodist_sbin_SCRIPTS = \
464         $(PYTHON_BOOTSTRAP_SBIN) \
465         daemons/ganeti-cleaner
466
467 dist_tools_SCRIPTS = \
468         tools/burnin \
469         tools/cfgshell \
470         tools/cfgupgrade \
471         tools/cfgupgrade12 \
472         tools/cluster-merge \
473         tools/lvmstrap \
474         tools/move-instance \
475         tools/setup-ssh \
476         tools/sanitize-config
477
478 pkglib_python_scripts = \
479         daemons/import-export \
480         tools/check-cert-expired
481
482 nodist_pkglib_python_scripts = \
483         tools/ensure-dirs
484
485 pkglib_SCRIPTS = \
486         daemons/daemon-util \
487         daemons/ensure-dirs \
488         tools/kvm-ifup \
489         $(pkglib_python_scripts)
490
491 nodist_pkglib_SCRIPTS = \
492         $(nodist_pkglib_python_scripts)
493
494 EXTRA_DIST = \
495         NEWS \
496         UPGRADE \
497         epydoc.conf.in \
498         pylintrc \
499         autotools/build-bash-completion \
500         autotools/check-python-code \
501         autotools/check-man \
502         autotools/check-news \
503         autotools/check-tar \
504         autotools/check-version \
505         autotools/docpp \
506         autotools/gen-coverage \
507         autotools/testrunner \
508         $(RUN_IN_TEMPDIR) \
509         daemons/daemon-util.in \
510         daemons/ensure-dirs.in \
511         daemons/ganeti-cleaner.in \
512         $(pkglib_python_scripts) \
513         devel/upload.in \
514         tools/kvm-ifup.in \
515         $(docdot) \
516         $(docpng) \
517         $(docrst) \
518         doc/conf.py \
519         doc/html \
520         doc/examples/ganeti.initd.in \
521         doc/examples/ganeti-kvm-poweroff.initd.in \
522         doc/examples/ganeti.cron.in \
523         doc/examples/gnt-config-backup.in \
524         doc/examples/ganeti.default \
525         doc/examples/ganeti.default-debug \
526         doc/examples/hooks/ethers \
527         doc/examples/hooks/ipsec.in \
528         doc/examples/gnt-debug/README \
529         doc/examples/gnt-debug/delay0.json \
530         doc/examples/gnt-debug/delay50.json \
531         test/testutils.py \
532         test/mocks.py \
533         $(dist_TESTS) \
534         $(TEST_FILES) \
535         man/footer.rst \
536         $(manrst) \
537         $(maninput) \
538         qa/qa-sample.json \
539         $(qa_scripts) \
540         $(HS_LIB_SRCS) $(HS_BUILT_SRCS_IN) \
541         $(HS_PROG_SRCS)
542
543 man_MANS = \
544         man/ganeti.7 \
545         man/ganeti-cleaner.8 \
546         man/ganeti-confd.8 \
547         man/ganeti-listrunner.8 \
548         man/ganeti-masterd.8 \
549         man/ganeti-noded.8 \
550         man/ganeti-os-interface.7 \
551         man/ganeti-rapi.8 \
552         man/ganeti-watcher.8 \
553         man/gnt-backup.8 \
554         man/gnt-cluster.8 \
555         man/gnt-debug.8 \
556         man/gnt-group.8 \
557         man/gnt-instance.8 \
558         man/gnt-job.8 \
559         man/gnt-node.8 \
560         man/gnt-os.8 \
561         man/hail.1 \
562         man/hbal.1 \
563         man/hscan.1 \
564         man/hspace.1
565
566 manrst = $(patsubst %.1,%.rst,$(patsubst %.7,%.rst,$(patsubst %.8,%.rst,$(man_MANS))))
567 manhtml = $(patsubst %.rst,%.html,$(manrst))
568 mangen = $(patsubst %.rst,%.gen,$(manrst))
569 maninput = \
570         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
571         $(patsubst %.html,%.html.in,$(manhtml)) \
572         man/footer.man man/footer.html $(mangen)
573
574 TEST_FILES = \
575         test/data/bdev-drbd-8.0.txt \
576         test/data/bdev-drbd-8.3.txt \
577         test/data/bdev-drbd-disk.txt \
578         test/data/bdev-drbd-net-ip4.txt \
579         test/data/bdev-drbd-net-ip6.txt \
580         test/data/cert1.pem \
581         test/data/proc_drbd8.txt \
582         test/data/proc_drbd80-emptyline.txt \
583         test/data/proc_drbd83.txt \
584         test/data/sys_drbd_usermode_helper.txt \
585         test/import-export_unittest-helper
586
587 python_tests = \
588         test/ganeti.asyncnotifier_unittest.py \
589         test/ganeti.backend_unittest.py \
590         test/ganeti.bdev_unittest.py \
591         test/ganeti.cli_unittest.py \
592         test/ganeti.client.gnt_cluster_unittest.py \
593         test/ganeti.client.gnt_instance_unittest.py \
594         test/ganeti.daemon_unittest.py \
595         test/ganeti.cmdlib_unittest.py \
596         test/ganeti.compat_unittest.py \
597         test/ganeti.confd.client_unittest.py \
598         test/ganeti.config_unittest.py \
599         test/ganeti.constants_unittest.py \
600         test/ganeti.errors_unittest.py \
601         test/ganeti.hooks_unittest.py \
602         test/ganeti.ht_unittest.py \
603         test/ganeti.http_unittest.py \
604         test/ganeti.hypervisor_unittest.py \
605         test/ganeti.hypervisor.hv_chroot_unittest.py \
606         test/ganeti.hypervisor.hv_fake_unittest.py \
607         test/ganeti.hypervisor.hv_kvm_unittest.py \
608         test/ganeti.hypervisor.hv_lxc_unittest.py \
609         test/ganeti.hypervisor.hv_xen_unittest.py \
610         test/ganeti.impexpd_unittest.py \
611         test/ganeti.jqueue_unittest.py \
612         test/ganeti.locking_unittest.py \
613         test/ganeti.luxi_unittest.py \
614         test/ganeti.masterd.instance_unittest.py \
615         test/ganeti.mcpu_unittest.py \
616         test/ganeti.netutils_unittest.py \
617         test/ganeti.objects_unittest.py \
618         test/ganeti.opcodes_unittest.py \
619         test/ganeti.qlang_unittest.py \
620         test/ganeti.query_unittest.py \
621         test/ganeti.rapi.baserlib_unittest.py \
622         test/ganeti.rapi.client_unittest.py \
623         test/ganeti.rapi.resources_unittest.py \
624         test/ganeti.rapi.rlib2_unittest.py \
625         test/ganeti.rpc_unittest.py \
626         test/ganeti.runtime_unittest.py \
627         test/ganeti.serializer_unittest.py \
628         test/ganeti.ssh_unittest.py \
629         test/ganeti.tools.ensure_dirs_unittest.py \
630         test/ganeti.uidpool_unittest.py \
631         test/ganeti.utils.algo_unittest.py \
632         test/ganeti.utils.filelock_unittest.py \
633         test/ganeti.utils.hash_unittest.py \
634         test/ganeti.utils.io_unittest.py \
635         test/ganeti.utils.log_unittest.py \
636         test/ganeti.utils.mlock_unittest.py \
637         test/ganeti.utils.nodesetup_unittest.py \
638         test/ganeti.utils.process_unittest.py \
639         test/ganeti.utils.retry_unittest.py \
640         test/ganeti.utils.text_unittest.py \
641         test/ganeti.utils.wrapper_unittest.py \
642         test/ganeti.utils.x509_unittest.py \
643         test/ganeti.utils_unittest.py \
644         test/ganeti.workerpool_unittest.py \
645         test/cfgupgrade_unittest.py \
646         test/docs_unittest.py \
647         test/tempfile_fork_unittest.py
648
649 haskell_tests = htools/test
650
651 dist_TESTS = \
652         test/check-cert-expired_unittest.bash \
653         test/daemon-util_unittest.bash \
654         test/ganeti-cleaner_unittest.bash \
655         test/import-export_unittest.bash \
656         $(python_tests)
657
658 nodist_TESTS =
659 if WANT_HTOOLS
660 nodist_TESTS += $(haskell_tests)
661 endif
662
663 TESTS = $(dist_TESTS) $(nodist_TESTS)
664
665 # Environment for all tests
666 PLAIN_TESTS_ENVIRONMENT = \
667         PYTHONPATH=. TOP_SRCDIR=$(abs_top_srcdir) PYTHON=$(PYTHON) $(RUN_IN_TEMPDIR)
668
669 # Environment for tests run by automake
670 TESTS_ENVIRONMENT = \
671         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
672
673 all_python_code = \
674         $(dist_sbin_SCRIPTS) \
675         $(dist_tools_SCRIPTS) \
676         $(pkglib_python_scripts) \
677         $(nodist_pkglib_python_scripts) \
678         $(python_tests) \
679         $(pkgpython_PYTHON) \
680         $(client_PYTHON) \
681         $(hypervisor_PYTHON) \
682         $(rapi_PYTHON) \
683         $(server_PYTHON) \
684         $(pytools_PYTHON) \
685         $(http_PYTHON) \
686         $(confd_PYTHON) \
687         $(masterd_PYTHON) \
688         $(impexpd_PYTHON) \
689         $(utils_PYTHON) \
690         $(watcher_PYTHON) \
691         $(noinst_PYTHON) \
692         $(qa_scripts)
693
694 srclink_files = \
695         man/footer.rst \
696         test/check-cert-expired_unittest.bash \
697         test/daemon-util_unittest.bash \
698         test/ganeti-cleaner_unittest.bash \
699         test/import-export_unittest.bash \
700         $(all_python_code) \
701         $(HS_LIB_SRCS) $(HS_PROG_SRCS)
702
703 check_python_code = \
704         $(BUILD_BASH_COMPLETION) \
705         $(DOCPP) \
706         $(all_python_code)
707
708 lint_python_code = \
709         ganeti \
710         ganeti/http/server.py \
711         $(dist_sbin_SCRIPTS) \
712         $(dist_tools_SCRIPTS) \
713         $(pkglib_python_scripts) \
714         $(BUILD_BASH_COMPLETION) \
715         $(DOCPP) \
716         $(PYTHON_BOOTSTRAP)
717
718 test/daemon-util_unittest.bash: daemons/daemon-util
719
720 test/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
721
722 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
723         sed -f $(REPLACE_VARS_SED) < $< > $@
724         chmod +x $@
725
726 devel/upload: devel/upload.in $(REPLACE_VARS_SED)
727         sed -f $(REPLACE_VARS_SED) < $< > $@
728         chmod u+x $@
729
730 daemons/%: daemons/%.in $(REPLACE_VARS_SED)
731         sed -f $(REPLACE_VARS_SED) < $< > $@
732         chmod +x $@
733
734 doc/examples/%: doc/examples/%.in $(REPLACE_VARS_SED)
735         sed -f $(REPLACE_VARS_SED) < $< > $@
736
737 doc/examples/hooks/%: doc/examples/hooks/%.in $(REPLACE_VARS_SED)
738         sed -f $(REPLACE_VARS_SED) < $< > $@
739
740 doc/examples/bash_completion: $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
741         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin
742         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_BASH_COMPLETION) > $@
743
744 doc/%.png: doc/%.dot
745         @test -n "$(DOT)" || { echo 'dot' not found during configure; exit 1; }
746         $(DOT) -Tpng -o $@ $<
747
748 man/footer.man: man/footer.rst
749         @test -n "$(PANDOC)" || \
750           { echo 'pandoc' not found during configure; exit 1; }
751         $(PANDOC) -f rst -t man -o $@ $<
752
753 man/footer.html: man/footer.rst
754         @test -n "$(PANDOC)" || \
755           { echo 'pandoc' not found during configure; exit 1; }
756         $(PANDOC) -f rst -t html -o $@ $<
757
758 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py
759         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@
760
761 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.man
762         @test -n "$(PANDOC)" || \
763           { echo 'pandoc' not found during configure; exit 1; }
764         set -o pipefail ; \
765         $(PANDOC) -s -f rst -t man -A man/footer.man $< | \
766           sed -e 's/\\@/@/g' > $@
767         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN) $@; fi
768
769 man/%.html.in: man/%.gen man/footer.html
770         @test -n "$(PANDOC)" || \
771           { echo 'pandoc' not found during configure; exit 1; }
772         set -o pipefail ; \
773         $(PANDOC) -s -f rst -t html -A man/footer.html $< | \
774           sed -e 's/\\@/@/g' > $@
775
776 man/%.1: man/%.1.in $(REPLACE_VARS_SED)
777         sed -f $(REPLACE_VARS_SED) < $< > $@
778
779 man/%.7: man/%.7.in $(REPLACE_VARS_SED)
780         sed -f $(REPLACE_VARS_SED) < $< > $@
781
782 man/%.8: man/%.8.in $(REPLACE_VARS_SED)
783         sed -f $(REPLACE_VARS_SED) < $< > $@
784
785 man/%.html: man/%.html.in $(REPLACE_VARS_SED)
786         sed -f $(REPLACE_VARS_SED) < $< > $@
787
788 epydoc.conf: epydoc.conf.in Makefile
789         sed -e 's#@MODULES@#$(strip $(lint_python_code))#g' < $< > $@
790
791 vcs-version:
792         if test -d .git; then \
793           git describe > $@; \
794         elif test ! -f $@ ; then \
795           echo "Cannot auto-generate $@ file"; exit 1; \
796         fi
797
798 .PHONY: regen-vcs-version
799 regen-vcs-version:
800         set -e; \
801         cd $(srcdir); \
802         if test -d .git; then \
803           rm -f vcs-version; \
804           $(MAKE) vcs-version; \
805         fi
806
807 htools/Ganeti/HTools/Version.hs: htools/Ganeti/HTools/Version.hs.in vcs-version
808         set -e; \
809         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
810         sed -e "s/%ver%/$$VCSVER/" < $< > $@
811
812 lib/_autoconf.py: Makefile vcs-version | lib/.dir
813         set -e; \
814         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
815         { echo '# This file is automatically generated, do not edit!'; \
816           echo '#'; \
817           echo ''; \
818           echo '"""Build-time configuration for Ganeti.'; \
819           echo '';\
820           echo 'This file is autogenerated by the build process.'; \
821           echo 'For any changes you need to re-run ./configure (and'; \
822           echo 'not edit by hand).'; \
823           echo ''; \
824           echo '"""'; \
825           echo ''; \
826           echo '# pylint: disable-msg=C0301,C0324'; \
827           echo '# because this is autogenerated, we do not want'; \
828           echo '# style warnings' ; \
829           echo ''; \
830           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
831           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
832           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
833           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
834           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
835           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
836           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
837           echo "SYSCONFDIR = '$(sysconfdir)'"; \
838           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
839           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
840           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
841           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
842           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
843           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
844           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
845           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
846           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
847           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
848           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
849           echo "KVM_PATH = '$(KVM_PATH)'"; \
850           echo "SOCAT_PATH = '$(SOCAT)'"; \
851           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
852           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
853           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
854           echo "TOOLSDIR = '$(toolsdir)'"; \
855           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
856           echo "PKGLIBDIR = '$(pkglibdir)'"; \
857           echo "DRBD_BARRIERS = $(DRBD_BARRIERS)"; \
858           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
859           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
860           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
861           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
862           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
863           echo "RAPI_USER = '$(RAPI_USER)'"; \
864           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
865           echo "CONFD_USER = '$(CONFD_USER)'"; \
866           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
867           echo "NODED_USER = '$(NODED_USER)'"; \
868           echo "VCS_VERSION = '$$VCSVER'"; \
869           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
870         } > $@
871
872 $(REPLACE_VARS_SED): Makefile
873         set -e; \
874         { echo 's#@PREFIX@#$(prefix)#g'; \
875           echo 's#@SYSCONFDIR@#$(sysconfdir)#g'; \
876           echo 's#@LOCALSTATEDIR@#$(localstatedir)#g'; \
877           echo 's#@BINDIR@#$(bindir)#g'; \
878           echo 's#@SBINDIR@#$(sbindir)#g'; \
879           echo 's#@GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
880           echo 's#@CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
881           echo 's#@CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
882           echo 's#@CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
883           echo 's#@CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
884           echo 's#@CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
885           echo 's#@RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
886           echo 's#@RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
887           echo 's#@PKGLIBDIR@#$(pkglibdir)#g'; \
888           echo 's#@GNTMASTERUSER@#$(MASTERD_USER)#g'; \
889           echo 's#@GNTRAPIUSER@#$(RAPI_USER)#g'; \
890           echo 's#@GNTCONFDUSER@#$(CONFD_USER)#g'; \
891           echo 's#@GNTNODEDUSER@#$(NODED_USER)#g'; \
892           echo 's#@GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
893           echo 's#@GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
894           echo 's#@GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
895           echo 's#@GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
896           echo 's#@GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
897         } > $@
898
899 # Using deferred evaluation
900 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
901 daemons/ganeti-watcher: MODULE = ganeti.watcher
902 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
903 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
904
905 $(PYTHON_BOOTSTRAP): Makefile | $(all_dirfiles)
906         test -n "$(MODULE)" || { echo Missing module; exit 1; }
907         set -e; \
908         { echo '#!/usr/bin/python'; \
909           echo '# This file is automatically generated, do not edit!'; \
910           echo "# Edit $(MODULE) instead."; \
911           echo; \
912           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
913           echo; \
914           echo '# pylint: disable-msg=C0103'; \
915           echo '# C0103: Invalid name'; \
916           echo; \
917           echo 'import sys'; \
918           echo 'import $(MODULE) as main'; \
919           echo; \
920           echo '# Temporarily alias commands until bash completion'; \
921           echo '# generator is changed'; \
922           echo 'if hasattr(main, "commands"):'; \
923                 echo '  commands = main.commands # pylint: disable-msg=E1101'; \
924           echo; \
925           echo 'if __name__ == "__main__":'; \
926           echo '  sys.exit(main.Main())'; \
927         } > $@
928         chmod u+x $@
929
930 # We need to create symlinks because "make distcheck" will not install Python
931 # files when building.
932 stamp-srclinks: Makefile | $(all_dirfiles)
933         set -e; \
934         for i in $(srclink_files); do \
935                 if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
936                         $(LN_S) $(abs_top_srcdir)/$$i $$i; \
937                 fi; \
938         done
939         touch $@
940
941 .PHONY: ganeti
942 ganeti:
943         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
944
945 .PHONY: check-dirs
946 check-dirs: $(BUILT_SOURCES)
947         @set -e; \
948         find . -type d \( \( -name . \) -o \( \
949                 -name .git -o \
950                 -name autom4te.cache \
951                 \) -prune -o -print \) | { \
952                 error=; \
953                 while read dir; do \
954                         case "$$dir" in \
955                                 $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
956                                 *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
957                         esac; \
958                 done; \
959                 for dir in $(DIRS); do \
960                         if ! test -d "$$dir"; then \
961                                 echo "Directory $$dir listed in DIRS does not exist" >&2; \
962                                 error=1; \
963                         fi \
964                 done; \
965                 if test -n "$$error"; then exit 1; else exit 0; fi; \
966         }
967
968 check-local: check-dirs
969         $(CHECK_PYTHON_CODE) $(check_python_code)
970         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
971         $(CHECK_NEWS) < $(top_srcdir)/NEWS
972
973 .PHONY: lint
974 lint: $(BUILT_SOURCES)
975         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
976         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
977         cd $(top_srcdir)/qa && \
978           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
979           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
980
981 .PHONY: hlint
982 hlint: $(HS_BUILT_SRCS)
983         if tty -s; then C="-c"; else C=""; fi; \
984         hlint --report=doc/hs-lint.html $$C htools
985
986 # a dist hook rule for updating the vcs-version file; this is
987 # hardcoded due to where it needs to build the file...
988 dist-hook:
989         $(MAKE) regen-vcs-version && \
990         rm -f $(top_distdir)/vcs-version && \
991         cp -p $(srcdir)/vcs-version $(top_distdir)
992
993 # a distcheck hook rule for catching revision control directories
994 distcheck-hook:
995         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
996                 echo "Found revision control files in final archive." 1>&2; \
997                 exit 1; \
998         fi
999         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1000                 echo "Found Python byte code in final archive." 1>&2; \
1001                 exit 1; \
1002         fi
1003         if find $(top_distdir) -name '*~' | grep .; then \
1004                 echo "Found backup files in final archive." 1>&2; \
1005                 exit 1; \
1006         fi
1007 # Empty files or directories should not be distributed. They can cause
1008 # unnecessary warnings for packagers. Directories used by automake during
1009 # distcheck must be excluded.
1010         if find $(top_distdir) -empty -and -not \( \
1011                         -path $(top_distdir)/_build -or \
1012                         -path $(top_distdir)/_inst \) | grep .; then \
1013                 echo "Found empty files or directories in final archive." 1>&2; \
1014                 exit 1; \
1015         fi
1016         if test -n "$(BUILD_RELEASE)" && \
1017            grep -n -H -E '^\*.*unreleased' $(top_distdir)/NEWS; then \
1018                 echo "Found unreleased version in NEWS." >&2; \
1019                 exit 1; \
1020         fi
1021
1022 # When building a release, stricter checks should be used
1023 distcheck-release dist-release: export BUILD_RELEASE = 1
1024 distcheck-release: distcheck
1025
1026 dist-release: dist
1027         set -e; \
1028         for i in $(DIST_ARCHIVES); do \
1029                 echo -n "Checking $$i ... "; \
1030                 autotools/check-tar < $$i; \
1031                 echo OK; \
1032         done
1033
1034 install-exec-local:
1035         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1036           "$(DESTDIR)${localstatedir}/log/ganeti" \
1037           "$(DESTDIR)${localstatedir}/run/ganeti"
1038
1039 # To avoid conflicts between directory names and other targets, a file inside
1040 # the directory is used to ensure its existence.
1041 %.dir:
1042         @mkdir_p@ $* && touch $@
1043
1044 .PHONY: apidoc
1045 if WANT_HTOOLSAPIDOC
1046 apidoc: py-apidoc hs-apidoc
1047 else
1048 apidoc: py-apidoc
1049 endif
1050
1051 .PHONY: py-apidoc
1052 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(BUILT_SOURCES)
1053         $(RUN_IN_TEMPDIR) epydoc -v \
1054                 --conf $(CURDIR)/epydoc.conf \
1055                 --output $(CURDIR)/$(APIDOC_PY_DIR)
1056
1057 .PHONY: hs-apidoc
1058 hs-apidoc: $(HS_BUILT_SRCS)
1059         @test -n "$(HSCOLOUR)" || \
1060             { echo 'HsColour' not found during configure; exit 1; }
1061         @test -n "$(HADDOCK)" || \
1062             { echo 'haddock' not found during configure; exit 1; }
1063         rm -rf $(APIDOC_HS_DIR)/*
1064         @mkdir_p@ $(APIDOC_HS_DIR)/Ganeti/HTools
1065         $(HSCOLOUR) -print-css > $(APIDOC_HS_DIR)/Ganeti/hscolour.css
1066         ln -s ../hscolour.css $(APIDOC_HS_DIR)/Ganeti/HTools/hscolour.css
1067         set -e ; \
1068         cd htools; \
1069         if [ "$(HTOOLS_NOCURL)" ]; \
1070         then OPTGHC="--optghc=$(HTOOLS_NOCURL)"; \
1071         else OPTGHC=""; \
1072         fi; \
1073         RELSRCS="$(HS_LIB_SRCS:htools/%=%)"; \
1074         for file in $$RELSRCS; do \
1075                 hfile=`echo $$file|sed 's/\\.hs$$//'`.html; \
1076                 $(HSCOLOUR) -css -anchor $$file > ../$(APIDOC_HS_DIR)/$$hfile ; \
1077         done ; \
1078         $(HADDOCK) --odir ../$(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1079                 -t ganeti-htools -p haddock-prologue \
1080                 --source-module="%{MODULE/.//}.html" \
1081                 --source-entity="%{MODULE/.//}.html#%{NAME}" \
1082                 $$OPTGHC \
1083                 $(filter-out Ganeti/HTools/ExtLoader.hs,$(HS_LIB_SRCS:htools/%=%))
1084
1085 .PHONY: TAGS
1086 TAGS: $(BUILT_SOURCES)
1087         rm -f TAGS
1088         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1089           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1090           -path './qa/*.py' | \
1091           etags -l python -
1092
1093 .PHONY: coverage
1094 if WANT_HTOOLS
1095 coverage: py-coverage hs-coverage
1096 else
1097 coverage: py-coverage
1098 endif
1099
1100 .PHONY: py-coverage
1101 py-coverage: $(BUILT_SOURCES) $(python_tests)
1102         set -e; \
1103         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1104         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1105         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1106         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/gen-coverage \
1107         $(python_tests)
1108
1109 .PHONY: hs-coverage
1110 hs-coverage: $(haskell_tests)
1111         cd htools && rm -f *.tix *.mix && ./test
1112         mkdir -p $(COVERAGE_HS_DIR)
1113         hpc markup --destdir=$(COVERAGE_HS_DIR) htools/test $(HPCEXCL)
1114         hpc report htools/test $(HPCEXCL)
1115         ln -s hpc_index.html $(COVERAGE_HS_DIR)/index.html
1116
1117 # Special "kind-of-QA" target for htools, needs special setup (all
1118 # tools compiled with -fhpc)
1119 .PHONY: live-test
1120 live-test: all
1121         set -e ; \
1122         cd htools; \
1123         rm -f .hpc; ln -s ../.hpc .hpc; \
1124         rm -f *.tix *.mix; \
1125         ./live-test.sh; \
1126         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:htools/%=%)) \
1127           --output=live-test.tix ; \
1128         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1129         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1130                 --srcdir=.. $(HPCEXCL) ; \
1131         hpc report --srcdir=.. live-test $(HPCEXCL)
1132
1133 commit-check: distcheck lint apidoc
1134
1135 -include ./Makefile.local
1136
1137 # vim: set noet :